import $ from 'jquery'
import qs from 'querystring';

function search(element) {
    return new Promise(function (resolve, reject) {
        resolve({
            element: element,
            search(query) {
                return fetch('/search/?' + qs.encode({q:query}))
                    .then(res => res.json())
                    .then(data => {
                        let actualResult = [];
                        $.each(data.hits, (key, value) => {
                            actualResult.push({
                                ref: value.id,
                                title: value.id.replace(/_/g, ' '),
                            })
                        })
                        return actualResult
                    })
            }
        })
    })
}

export default search;
